/*
 * ring_queue.c
 *
 *  Created on: 2024621
 *      Author: psx
 */


//ѭ
#include <stdio.h>
#include <stdlib.h>
#include "ring_queue.h"

//#define RING_QUEUE_DEBUG

//#ifdef RING_QUEUE_DEBUG
//#define //rq_debug term_printf
//#else
//void rq_debug(const char *fmt, ...){};
//#endif

//ʼ
int InitRingQueue(RingQueue *q, RQ_ElementType *buff, int size)
{
    q->elems = buff;
    q->size = size;
    q->front=q->rear=0;
    return RQ_OK;
}

//,
//ʹãʶ߿޸ĵrearȶȡ
int ShowRingQueue(RingQueue *q)
{
    //int i;
    int rear = q->rear;

    if(q->front == rear)
    {
        //rq_debug("Ϊ\n");
        return RQ_ERROR;
    }
    //rq_debug("еԪΪ:\n");
    //for(i=((q->front)%q->size); i !=  rear; i=((i+1)%q->size))
        //rq_debug(" %c\n",q->elems[i]);

    //rq_debug("\n");
    //rq_debug("ԪΪ%c\n",q->elems[q->front]);
    //rq_debug("βԪΪ%c\n",q->elems[rear - 1]);
    return RQ_OK;
}

//βԪe
int InRingQueue(RingQueue *q,RQ_ElementType e)
{
    if(RingQueueFull(q))
    {
        //rq_debug("ռ䲻\n");
        return(RQ_OVERFLOW);
    }
    q->elems[q->rear] = e;
    q->rear = (q->rear+1) % q->size;
    //rq_debug("rear = %d\n",q->rear);
    return RQ_OK;
}

//ӶȡزɾԪ
int OutRingQueue(RingQueue *q, RQ_ElementType *e)
{
    if(RingQueueEmpty(q))
    {
        //rq_debug("Ϊ\n");
        return RQ_ERROR;
    }
        *e = q->elems[q->front];
    //rq_debug("ɾĶԪΪ%c\n",q->elems[q->front]);
    q->front = (q->front+1) % q->size;
    return RQ_OK;
}

//еԪظ
int RingQueueLength(RingQueue *q)
{
    return ((q->rear - q->front) + q->size) % q->size;
}


